<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8">
  <title>Classwork</title>

  <script>
    document.addEventListener("DOMContentLoaded", function () {

      /*
        Задание:
        1. При помощи методов изложеных ниже, переформатировать ITEA_COURSES в массив который содержит длину строк каждого из элементов.
        2. Самостоятельно изучить метод Array.sort. Отфильтровать массив ITEA_COURSES по алфавиту.
            + Бонусный бал. Вывести на страничку списком
        3. Реализация функции поиска по массиву ITEA_COURSES.
            + Бонусный бал. Вывести на страничку инпут и кнопку по которой будет срабатывать поиск.
      */

      const ITEA_COURSES = ["Курс HTML & CSS", "JavaScript базовый курс", "JavaScript продвинутый курс", "JavaScript Professional", "Angular 2.4 (базовый)", "Angular 2.4 (продвинутый)", "React.js", "React Native", "Node.js", "Vue.js"];
      const divSort = document.getElementById('divId');

      //1. length
      let newArray = ITEA_COURSES.forEach(element => element.length);
      //2. sort + bonus
      let sortArray = ITEA_COURSES.sort();

      function displaySortArray() {
        sortArray.map(element => {
          let div = document.createElement('div');
          div.innerText = element;
          divSort.appendChild(div);
        })
      }

      displaySortArray();

      //3. find + bonus
      let inputFind = document.createElement('input');
      let btnFind = document.createElement('button');
      btnFind.innerText = "Find";
      btnFind.addEventListener('click', findClick)
      divSort.appendChild(inputFind);
      divSort.appendChild(btnFind);

      function findInArray(element, index, array) {
        let text = inputFind.value;
        if (element === text) {
          let div = document.createElement('div');
          div.innerText = element;
          divSort.appendChild(div);
        }
      }

      function findClick(e) {
        ITEA_COURSES.find(findInArray);
      }

      /*
        Задание 2:
        Написать фильтр массива по:
        Актеру, продолжительности
  
        Бонус:
          Сделать графическую оболочку для программы:
          - Селект со списком актеров
          - Селект или инпут с продолжительностью
          - Результат в виде списка фильмов
      */

      const selectStarring = document.getElementById("selectStarring");
      const selectDuration = document.getElementById("selectDuration");
      const btnFilter = document.getElementById("btnFilter");
      btnFilter.addEventListener('click', setFilter);
      const divMovies = document.getElementById("divMovies");

      var stars = ['Elijah Wood', 'Ian McKellen', 'Orlando Bloom', 'Ewan McGregor', ' Liam Neeson', 'Natalie Portman', 'Billy Bob Thornton', 'Martin Freeman']
      var movies = [
        {
          name: "Lord of the Rigs",
          duration: 240,
          starring: ['Elijah Wood', 'Ian McKellen', 'Orlando Bloom']
        },
        {
          name: "Star Wars: Episode I - The Phantom Menace",
          duration: 136,
          starring: ['Ewan McGregor', ' Liam Neeson', 'Natalie Portman']
        },
        {
          name: "Fargo",
          duration: 100,
          starring: ['Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
        },
        {
          name: "V for Vendetta",
          duration: 150,
          starring: ['Hugo Weaving', 'Natalie Portman', 'Rupert Graves']
        }
      ];

      function fillSelector(array) {
        array.forEach(text => this.appendChild(createOption(text)));
      }

      function createOption(text) {
              let option = document.createElement("option");
              option.innerText = text;
              return option;
          }

      fillSelector.call(selectStarring, stars);
      fillSelector.call(selectDuration, movies.map(movie => movie.duration));

      function setFilter(){
        let starringSelected = selectStarring.value;
        let durationSelected = selectDuration.value;

        let intermediateArray = movies.filter(element => element.duration >= durationSelected);
        let result = intermediateArray.filter(element => element.starring.some(el => el === starringSelected));

        DisplayMovies(result);
      }

      function DisplayMovies(moviesArray){
        moviesArray.map(element => {
          let div = document.createElement('div');
          div.innerText = element.name;
          divMovies.appendChild(div);
        })      }
    })
  </script>

</head>

<body>
  <div id="divId"></div>
  <p></p>
  <select id="selectStarring"></select>
  <select id="selectDuration"></select>
  <button id="btnFilter">Filter</button>
  <div id="divMovies"></div>
</body>

</html>